library(stockassessment)
load("run/model.RData")

# residuals --------------------------------------------------------------------
options(mc.cores=4)

dat<-fit$data
dis<-dat$fleetTypes[dat$aux[,"fleet"]]==5
res<-TMB::oneStepPredict(fit$obj, observation.name="logobs", data.term.indicator="keep", discrete=FALSE, subset=which(!dis), parallel=TRUE)
res2<-TMB::oneStepPredict(fit$obj, observation.name="logobs", data.term.indicator="keep", discrete=TRUE, conditional=which(!dis),
                          subset=which(dis), method ="oneStepGeneric", range=c(0,Inf), parallel=TRUE)

totalres<-rep(NA,nrow(dat$aux))
totalres[!dis]<-res$residual
totalres[dis]<-res2$residual
RES<-data.frame(dat$aux, residual=totalres)

TAGRES<-RES[RES$fleet==5,]
RES$residual[RES$fleet==5]<-NA
class(RES)<-"samres"
attr(RES, "fleetNames")<-attr(fit$data, "fleetNames")
RESP<-procres(fit)
RESP<-procres(fit)
save(RES, RESP, TAGRES, file="run/residuals.RData")












